<?php

declare(strict_types=1);

namespace App\Service;

use App\Repository\TblRolUsuarioRepository;

final class TblRolUsuarioService
{
    private TblRolUsuarioRepository $TblRolUsuarioRepository;

    public function __construct(TblRolUsuarioRepository $TblRolUsuarioRepository)
    {
        $this->TblRolUsuarioRepository = $TblRolUsuarioRepository;
    }

    public function checkAndGet(int $TblRolUsuarioId): object
    {
        return $this->TblRolUsuarioRepository->checkAndGet($TblRolUsuarioId);
    }

    public function getAll(): array
    {
        return $this->TblRolUsuarioRepository->getAll();
    }

    public function getOne(int $TblRolUsuarioId): object
    {
        return $this->checkAndGet($TblRolUsuarioId);
    }

    public function create(array $input): object
    {
        $TblRolUsuario = json_decode((string) json_encode($input), false);

        return $this->TblRolUsuarioRepository->create($TblRolUsuario);
    }

    public function update(array $input, int $TblRolUsuarioId): object
    {
        $TblRolUsuario = $this->checkAndGet($TblRolUsuarioId);
        $data = json_decode((string) json_encode($input), false);

        return $this->TblRolUsuarioRepository->update($TblRolUsuario, $data);
    }

    public function delete(int $TblRolUsuarioId): void
    {
        $this->checkAndGet($TblRolUsuarioId);
        $this->TblRolUsuarioRepository->delete($TblRolUsuarioId);
    }
}
